LearningDataCount = 192
VerificationDataCount = 4096
SignificantBits = 8

def formula(a, b, c, d, e, f, g, h)
  ((a ^ b) | ((c & d) | (c & e) | (d & e))) & ((f & g) | (f & h) | (g & h))
end

def generate_data_file(filename, number)
  File.open(filename, "w+") do |file|
    number.times do
      a = rand < 0.5
      b = rand < 0.5
      c = rand < 0.5
      d = rand < 0.5
      e = rand < 0.5
      f = rand < 0.5
      g = rand < 0.5
      h = rand < 0.5
      i = rand < 0.5
      j = rand < 0.5
      x = formula(a, b, c, d, e, f, g, h)
      a = a ? +1.0 : -1.0
      b = b ? +1.0 : -1.0
      c = c ? +1.0 : -1.0
      d = d ? +1.0 : -1.0
      e = e ? +1.0 : -1.0
      f = f ? +1.0 : -1.0
      g = g ? +1.0 : -1.0
      h = h ? +1.0 : -1.0
      i = i ? +1.0 : -1.0
      j = j ? +1.0 : -1.0
      x = x ? +1.0 : -1.0
      file << "#{a}, #{b}, #{c}, #{d}, #{e}, #{f}, #{g}, #{h}, #{i}, #{j}, #{x}\n"
    end
  end
end

generate_data_file("test.learning_data.csv", LearningDataCount)
generate_data_file("test.data.csv", VerificationDataCount)

system("./auto-nng -t 90 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 o11 < test.learning_data.csv > test.network.nn") or exit 1
system("./auto-nng run test.network.nn < test.data.csv > test.results.csv") or exit 1

correct = 0
wrong = 0
yes = 0
no = 0

File.open("test.results.csv", "r") do |file|
  while line = file.gets
    if line !~ /^([^,]*),([^,]*),([^,]*),([^,]*),([^,]*),([^,]*),([^,]*),([^,]*),([^,]*),([^,]*),([^,]*)$/
      raise "Could not parse results."
    end
    a = $1.to_f > 0
    b = $2.to_f > 0
    c = $3.to_f > 0
    d = $4.to_f > 0
    e = $5.to_f > 0
    f = $6.to_f > 0
    g = $7.to_f > 0
    h = $8.to_f > 0
    i = $9.to_f > 0
    j = $10.to_f > 0
    x = $11.to_f > 0
    calc_x = formula(a, b, c, d, e, f, g, h)
    if calc_x
      yes += 1
    else
      no += 1
    end
    if x == calc_x
      correct += 1
    else
      wrong += 1
    end
  end
end

puts

total = correct + wrong
correct /= total.to_f
wrong /= total.to_f

if yes > no
  bias = no.to_f / (yes + no).to_f
elsif no > yes
  bias = yes.to_f / (yes + no).to_f
else
  bias = 0.5
end

limit = Math.exp(-LearningDataCount.to_f/(2**SignificantBits).to_f) * bias

printf "%2.2f %% correct.\n", 100.0 * correct
printf "%2.2f %% wrong.\n", 100.0 * wrong
puts
printf "Limit: %2.2f %%.\n", 100.0 * limit

puts
if wrong < limit
  puts "Test passed."
else
  puts "Test failed, please try again."
end
